<template>
    <div class="modal">
        <div class="modal__blackout" @click="destroy"></div>
        <div class="modal__body card">
            <template v-if="order.status == 'viewed'">
                <div class="card__header">
                    <h2 class="card__">Заказ #{{ order.body.id }}</h2>
                    <CloseButton className="modal__close" @close="destroy" />
                </div>
                <div class="card__content">
                    <p class="modal__caption">Корзина</p>
                    <ul class="modal__list">
                        <li v-for="item in order.body.basket_items" :key="item.id" class="modal__item basket-item card card--primary">
                            <div class="basket-item__description">
                                <span class="basket-item__name">{{ item.name }}</span>
                                <span class="basket-item__count">{{ item.quantity }} шт.</span>
                            </div>
                            <span class="basket-item__price">
                                {{ item.price }} руб.
                            </span>
                        </li>
                    </ul>
                </div>
                <div class="modal__footer">
                    <AppButton
                        @handle="$emit('toDelivery')"
                        className="modal__button"
                        title="К отгрузке"
                        status="success"
                    />
                    <AppButton
                        @handle="$emit('remove')"
                        className="modal__button"
                        title="Отменить"
                        status="danger"
                    />
                </div>
            </template>
            <AppLoader v-if="order.status == 'loading'" />
        </div>
    </div>
</template>

<script>
import AppLoader from './AppLoader';
import CloseButton from './Buttons/CloseButton';
import AppButton from './Buttons/AppButton';

export default {
    components: {
        AppLoader, CloseButton, AppButton
    },
    props: {
        id: Number
    },
    data() {
        return {
            order: {
                status: 'waiting',
                body: {}
            },
            FETCH_URL: 'https://demo-api.vsdev.space/api/orders_admin/20210603/'
        }
    },
    methods: {
        async loadOrderDescription(id) {
            this.order.status = 'loading';

            const URL = this.FETCH_URL + 'orders/' + id;

            let response = await fetch(URL);
            this.order.body = await response.json();

            this.order.status = 'viewed';
        },
        destroy() {
            this.$emit('close');
        },
        keyHandler(event) {
            if (event.key == 'Escape') this.destroy();
        }
    },
    mounted() {
        this.loadOrderDescription(this.id);
        document.addEventListener('keydown', this.keyHandler);
    },
    beforeUnmounted() {
        document.removeEventListener('keydown', this.keyHandler);
    }
 }
</script>

<style>

</style>